#!/usr/bin/env ruby
# encoding: utf-8

$LOAD_PATH << '../lesslinux-bankcrawler'
$LOAD_PATH << '/usr/share/lesslinux/banking'

require 'gtk2'
require "rexml/document"
require "bankcrawler.rb"

def create_popup(menu, parent, panel, window, http_expas, xml_frag, blz)
	mennew = Gtk::MenuItem.new("Neue Bank hinzufügen")
	mendel = Gtk::MenuItem.new("Diese Bank löschen")
	menadd = Gtk::MenuItem.new("Einzelne Seite hinzufügen")
	mencrl = Gtk::MenuItem.new("Neue Bankseite einlesen")

	menu.append(mennew)
	menu.append(mendel)
	menu.append(menadd)
	menu.append(mencrl)

	mennew.signal_connect('activate') { |w| 
		select_bank(window, panel)
	}
	mendel.signal_connect('activate')  { |w|
		# $stderr.puts bpos.to_s 
		$stderr.puts blz
		delete_bank(blz.to_i)
		parent.expanded = false
		parent.sensitive = false
	}
	menadd.signal_connect('activate') { |w|
		add_single_host(window, http_expas, xml_frag) 
	}
	mencrl.signal_connect('activate') { |w|
		crawl_and_add(window, panel) 
	}
	menu.show_all
end

def create_panel_popup(menu, panel, window)
	mennew = Gtk::MenuItem.new("Neue Bank hinzufügen")
	mencrl = Gtk::MenuItem.new("Neue Bankseite einlesen")
	menu.append(mennew)
	menu.append(mencrl)
	mennew.signal_connect('activate') { |w| 
		select_bank(window, panel)
	}
	mencrl.signal_connect('activate') { |w|
		crawl_and_add(window, panel) 
	}
	menu.show_all
end

def delete_bank(blz)
	# $deleted_banks.push(blz)
	$removed_hosts = true
	$bankfrags.delete(blz)
	# puts $deleted_banks.join(", ")
	# puts $bankfrags.keys.join(", ")
end

def add_single_host(window, http_expas, xml_frag)
	host_to_add = nil
	host_frag = xml_frag.elements["hosts[@class='http']"]
	# $stderr.puts host_frag.to_s
	dialog = Gtk::Dialog.new(
	"Server hinzufügen",
	window,
	Gtk::Dialog::MODAL,
	[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ])
	dialog.has_separator = false

	entry = Gtk::Entry.new
	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	hbox.pack_start_defaults(entry);
	dialog.vbox.add(hbox)
	dialog.show_all
	dialog.run { |res|
		if res == Gtk::Dialog::RESPONSE_OK
			host_to_add = entry.text
		end
		dialog.destroy
	}
	unless host_to_add.nil?
		cleaned_hostname = host_to_add.gsub("http://", "").gsub("https://", "")
		if cleaned_hostname =~ /\//
			name_toks = cleaned_hostname.split("/")
			cleaned_hostname = name_toks[0]
		end
		# $stderr.puts(xml_frag.to_s)
		chebo = Gtk::CheckButton.new(cleaned_hostname.strip)
		# host_frag
		host_xnode = host_frag.add_element("host")
		host_xnode.add_attribute("name", cleaned_hostname.strip)
		host_xnode.add_attribute("active", "yes")
		chebo.active = true
		chebo.signal_connect("toggled") { |c|
			if c.active? == false
				host_xnode.attributes["active"] = 'no' 
				$removed_hosts = true
			else
				host_xnode.attributes["active"] = 'yes'
			end
			# $stderr.puts host_frag.to_s
			
		}
		http_expas.pack_start(chebo)
		http_expas.show_all
	end
	$pending_changes = true
end

def prep_blz_list(blzxml)
	blzlist = Array.new
	blzxml.elements.each("banklist/bank") { |node|
		if node.attributes["blz"].to_i > 0
			blzlist.push(node.attributes["blz"])
			blzlist.push(node.attributes["url"])
		end
	}
	blzlist.sort!
	blzlist.uniq!
	return blzlist
end

def search_matching_xml(identifyer)
	return nil, nil, nil, nil if identifyer.to_s.strip == ""
	valid_blzs = Array.new
	valid_host = nil
	valid_blz = nil
	valid_name = nil
	valid_city = nil
	isblz = false
	isblz = true if identifyer.to_i > 0
	$blzxml.elements.each("banklist/bank") { |node|
		if isblz == true
			if node.attributes["blz"] == identifyer.strip
				valid_host = node.attributes["url"]
				valid_blz = node.attributes["blz"]
				valid_name = node.attributes["name"]
				valid_city = node.attributes["city"]
				$stderr.puts("BLZ found!")
			end
		else
			if node.attributes["url"] == identifyer.strip
				valid_host = node.attributes["url"]
				valid_blz = node.attributes["blz"]
				valid_name = node.attributes["name"]
				valid_city = node.attributes["city"]
				valid_blzs.push(node.attributes["blz"])
			end
		end
	}
	if isblz == true
		if system("test -f " + $blzdir + "/" + identifyer + ".xml")
			xmlfrag = REXML::Document.new(File.new($blzdir + "/" + identifyer + ".xml"))
			return xmlfrag, valid_blz, valid_name
		end
		$blzxml.elements.each("banklist/bank") { |node|
			if node.attributes["url"] == valid_host
				# valid_blz = node.attributes["blz"]
				# valid_name = node.attributes["name"]
				valid_blzs.push(node.attributes["blz"])
				$stderr.puts("VALID BLZ FOR FOUND HOST " + node.attributes["blz"] ) # , valid_blz, valid_name
			end
		}
	end
	valid_blzs.each { |b|
		$stderr.puts("VALID BLZ FOR KNOWN HOST " + b)
		if system("test -f " + $blzdir + "/" + b + ".xml")
			xmlfrag = REXML::Document.new(File.new($blzdir + "/" + b + ".xml"))
			return xmlfrag, valid_blz, valid_name, valid_city
		end
	}
	return nil, nil, nil, nil
end

def crawl_and_add(window, panel)
	dialog = Gtk::Dialog.new(
	"Crawl starten",
	window,
	Gtk::Dialog::MODAL,
	[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
	[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ])
	dialog.has_separator = true
	
	# hbox = Gtk::HBox.new(false, 5)
	# hbox.border_width = 10
	# model = Gtk::ListStore.new(String)
	# label = Gtk::Label.new("BLZ oder Webadresse:")
	# comen = Gtk::ComboBoxEntry.new(model, 0)
	# hbox.pack_start_defaults(label);
	# hbox.pack_start_defaults(comen);
	
	# Layouttable
	
	toplabel = Gtk::Label.new("Geben Sie Name der Bank, BLZ und Startseite ein und drücken Sie dann \"OK\" um die Bankwebseite einzulesen. In der Regel dauert die Analyse etwa eine Minute, im Extremfall können jedoch zehn bis fünfzehn Minuten vergehen.")
	toplabel.wrap = true
	label1 = Gtk::Label.new("Name der Bank:")
	label2 = Gtk::Label.new("BLZ:")
	label3 = Gtk::Label.new("Startseite:")

	bname = Gtk::Entry.new
	blz = Gtk::Entry.new
	burl = Gtk::Entry.new

	table = Gtk::Table.new(4, 2, false)
	table.attach_defaults(toplabel, 0, 2, 0, 1)
	table.attach_defaults(label1, 0, 1, 1, 2)
	table.attach_defaults(label2, 0, 1, 2, 3)
	table.attach_defaults(label3, 0, 1, 3, 4) 
	table.attach_defaults(bname,   1, 2, 1, 2)
	table.attach_defaults(blz,   1, 2, 2, 3)
	table.attach_defaults(burl,   1, 2, 3, 4)
	table.row_spacings = 5
	table.column_spacings = 5
	table.border_width = 10
	
	dialog.vbox.add(table)
	dialog.show_all
	response_xml = nil
	identifyer = nil
	bnstr = nil
	blstr = nil
	bustr = nil
	dialog.run { |response|
		case response
		when Gtk::Dialog::RESPONSE_OK
			bnstr = bname.text.to_s
			blstr = blz.text.to_s
			bustr = burl.text.to_s
		end
		dialog.destroy
	}
	response_xml = start_crawl(bnstr, blstr, bustr, window) unless bustr.nil?
	# unless
	# $stderr.puts response_xml.to_s
	# rnode = response_xml.root.clone
	showed_name = bnstr
	showed_name = bustr if bnstr.to_s.strip == ""
	skip_blz = false
	skip_blz = true if blstr.strip.to_i < 1
	add_bank(response_xml.root, panel, window, blstr.to_s, showed_name, skip_blz) unless response_xml.nil?
end

def start_crawl(bankname, blz, starturl, parent)
	if $bankfrags.has_key?(blz.to_i)
		show_warning(parent, "Eine Bank mit dieser BLZ existiert bereits in der Liste. Löschen Sie diese zuerst, bevor Sie eine Analyse der Bankwebseite starten.")
		return nil
	end
	if starturl.to_s.strip.split(".").size < 2
		show_warning(parent, "Diese angebene URL der Bankwebseite ist leer oder unzulässig.")
		return nil
	end
	use_bankname = bankname
	use_blz = blz
	use_bankname = starturl if bankname.strip == ""
	use_blz = rand(1_000_000_000) if blz.to_i < 1
	return nil if starturl.to_s.strip.split(".").size < 2
	xmlfrag = REXML::Document.new
	xmlfrag.add_element("bank")
	xmlfrag.root.add_attribute("name", use_bankname.strip)
	xmlfrag.root.add_attribute("blz", use_blz.to_s)
	http_node = xmlfrag.root.add_element("hosts")
	http_node.add_attribute("class", "http")
	https_node = xmlfrag.root.add_element("hosts")
	https_node.add_attribute("class", "https")
	bserver = starturl.gsub("http://", "").gsub("https://", "")
	xmlfrag.root.add_attribute("name", use_bankname.strip)
	xmlfrag.root.add_attribute("starturl", bserver.strip)
	servertoks = bserver.split("/")
	domtoks = servertoks[0].split(".")
	tld = domtoks[-1]
	dom = domtoks[-2]
	crwl = SinglePage.new(starturl, 0.0, blz.to_i)
	https_hosts = Array.new
	crwl.retrieve_hostprotos.each { |h|
		if h["proto"] == "https"
			https_hosts.push(h["host"])
			host = https_node.add_element("host")
			host.add_attribute("name", h["host"].to_s)
			host.add_attribute("active", "yes")
		end
	}
	crwl.retrieve_hostprotos.each { |h|
		if h["proto"] == "http" && !https_hosts.include?(h["host"])
			host = http_node.add_element("host")
			host.add_attribute("name", h["host"].to_s)
			h_domtoks = h["host"].split(".")
			if h_domtoks[-1] == tld && h_domtoks[-2] == dom
				host.add_attribute("active", "yes")
			else
				host.add_attribute("active", "no")
			end
		end
	}
	if crwl.https_ok == true
		xmlfrag.root.add_attribute("toplevelhttps", "true")
	else
		xmlfrag.root.add_attribute("toplevelhttps", "false")
	end
	# $stderr.puts xmlfrag.to_s
	return xmlfrag
end

def select_bank(pwin, panel)
	dialog = Gtk::Dialog.new(
	"Banksuche",
	pwin,
	Gtk::Dialog::MODAL,
	[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ])
	dialog.has_separator = true
	# label = Gtk::Label.new("The button was clicked!")
	# image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)
	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	model = Gtk::ListStore.new(String)
	label = Gtk::Label.new("BLZ oder Webadresse:")
	comen = Gtk::ComboBoxEntry.new(model, 0)
	hbox.pack_start_defaults(label);
	hbox.pack_start_defaults(comen);
	dialog.vbox.add(hbox)
	dialog.show_all
	comen.signal_connect("key-release-event") { |x, y|
		narrow_banklist(comen, comen.active_text)
	}
	identifyer = nil
	ok_clicked = false
	dialog.run { |response|
		case response
		when Gtk::Dialog::RESPONSE_OK
			identifyer = comen.active_text
			ok_clicked = true
			$stderr.puts("Search for: " + comen.active_text)
		end
		dialog.destroy
	}
	xml_fragment, blz, name, city = search_matching_xml(identifyer.to_s)
	# some fine tuning on name and city
	name = merge_name_city(name, city)
	name = identifyer.to_s.strip if identifyer.to_i < 1
	if xml_fragment.nil? && ok_clicked == true
		show_warning(pwin, "Zu Ihrer Eingabe wurde keine passende Bank gefunden. Sie können jedoch im Kontextmenüpunkt \"Neue Bankseite einlesen\" eine Analyse der Webseite Ihrer Bank durchführen.")
	end
	unless xml_fragment.nil?
		if identifyer.to_i < 1
			add_bank(xml_fragment.root, panel, pwin, blz, name, true )
		else
			add_bank(xml_fragment.root, panel, pwin, blz, name, false )
		end
	end
	# return xml_fragment
end

def merge_name_city(name, city)
	return name if city.to_s.strip == ""
	return name unless name.downcase.index(city.downcase).nil?
	return name + " " + city
end

def narrow_banklist(combo_entry, typed_text)
	$stderr.puts typed_text
	iter = combo_entry.model
	iter.clear
	narrow_list = Array.new
	$blzlist.each { |item|
		if item =~ Regexp.new("^" + typed_text) ||  item =~ Regexp.new("^www." + typed_text)
			narrow_list.push(item)
		end
	}
	if narrow_list.size > 0 && narrow_list.size <= 50
		narrow_list.each { |n|
			newrow = iter.append
			newrow[0] = n
		}
	end
	combo_entry.popup if narrow_list.size > 1 && narrow_list.size <= 20
end

def write_back(parent)
	show_warning(parent, "Bitte schließen Sie das Internet-Zugangsprogramm. Die geänderten Einstellungen für die Startseite werden sonst nicht gespeichert.") if check_ff_running
	doc = REXML::Document.new
	doc.add_element("allowedbanks")
	$bankfrags.each { |k, v|
		if $deleted_banks.include?(k)
			$stderr.puts("Skipping deleted bank: " + k.to_s)
		else
			# $stderr.puts("Dumping XML fragment: " + v.to_s)
			doc.root.add(v)
		end
	}
	# $stderr.puts(doc.to_s)
	outfile = File.open($cfgdir + "/allowedservers.xml", "w")
	doc.write( outfile, 4)
	outfile.close
	control_count = write_smack_rules
	$pending_changes = false
	if $removed_hosts == true
		show_warning(parent, "Achtung: Aus der Liste gelöschte Server sind noch bis zum nächsten Neustart aktiv!")
	end
	if control_count < 0
		show_warning(parent, "Achtung: Es konnten nicht die Adressen aller Server ermittelt werden. Dies deutet auf Probleme mit der Internetverbindung hin!")
	else
		show_message(parent, "Die geänderten Einstellungen wurden gespeichert.")
	end
end

def write_smack_rules
	write_homepages
	valid_hosts = Array.new
	valid_ips = Array.new
	hostcount = 0
	dnscount = 0
	$bankfrags.each { |k, v|
		if $deleted_banks.include?(k)
			$stderr.puts("Skipping deleted bank: " + k.to_s)
		else
			v.elements.each("hosts/host") { |h|
				if h.attributes["active"] == "yes"
					# $stderr.puts(h.attributes["name"])
					valid_hosts.push(h.attributes["name"])
				end
			}
		end
	}
	valid_hosts.uniq!
	valid_hosts.each { |h|
		inside_answer = false
		# $stderr.puts("Valid: " + h)
		if check_for_ip(h) == true
			valid_ips.push(h)
		else
			hostcount += 1
			IO.popen("nslookup '" + h + "'") { |io|
				while io.gets
					toks = $_.split
					inside_answer = true if toks[0] =~ /^Name:/
					if inside_answer == true && !toks[1].nil? && toks[0] =~ /^Address:/
						valid_ips.push(toks[1])
						dnscount += 1
					elsif inside_answer == true && !toks[2].nil? && toks[0] =~ /^Address/ && toks[1] =~ /:$/
						valid_ips.push(toks[2])
						dnscount += 1
					end
				end
			}
		end
	}
	# Add nameservers to valid_ips
	if File.exists?("/etc/resolv.conf")
		File.open("/etc/resolv.conf").each { |line|
			toks = line.split
			valid_ips.push(toks[1].strip) if toks[0].strip =~ /^nameserver/
		}
	end
	system("rm " + $outdir + "/smack.netlabel.???.txt")
	valid_ips.uniq!
	ofcount = 0
	valid_ips.each { |ip|
		$stderr.puts("Dumping: " + ip)
		outfile = File.open($outdir + "/smack.netlabel." + sprintf("%03d", ofcount) + ".txt", 'w')
		outfile.write(ip + " outgoing\n") 
		outfile.close
		system("cat " + $outdir + "/smack.netlabel." + sprintf("%03d", ofcount) + ".txt > /smack/netlabel")
		ofcount += 1
	}
	return dnscount - hostcount
end

def show_warning(parent, text)
	dialog = Gtk::MessageDialog.new(parent, 
			Gtk::Dialog::MODAL,
			Gtk::MessageDialog::WARNING,
			Gtk::MessageDialog::BUTTONS_CLOSE,
			text)
	dialog.run
	dialog.destroy
end

def show_message(parent, text)
	dialog = Gtk::MessageDialog.new(parent, 
			Gtk::Dialog::MODAL,
			Gtk::MessageDialog::INFO,
			Gtk::MessageDialog::BUTTONS_CLOSE,
			text)
	dialog.run
	dialog.destroy
end

def check_for_ip(host_or_ip)
	toks = host_or_ip.split(".")
	return false unless toks.size == 4
	return false if toks[0].to_i < 2
	toks.each { |t|
		return false if t.to_i < 1 || t.to_i > 255 
	}
	return true
end

def write_homepages
	homepage_urls = Array.new
	$bankfrags.each { |k, v|
		if $deleted_banks.include?(k)
			$stderr.puts("Skipping deleted bank: " + k.to_s)
		else
			pref_host = v.attributes["starturl"].gsub("http://", "").gsub("https://", "")
			pref_https = v.attributes["toplevelhttps"]
			if pref_https == "true"
				homepage_urls.push("https://" + pref_host)
			else
				homepage_urls.push("http://" + pref_host)
			end
		end
	}
	prefhandle = File.open($prefs, "a")
	prefhandle.write("user_pref(\"browser.startup.homepage\", \"" + homepage_urls.join("|") + "\");\n")
	prefhandle.close
end

def add_bank(xbnode, pwidget, window, blz, name, skip_blz)
	use_blz = blz
	use_blz = rand(1_000_000_000) if blz.to_i < 1
	# First check if bank already exists, abort with an error if
	# this should be the case
	if $bankfrags.has_key?(blz.to_i)
		dialog = Gtk::Dialog.new(
		"Bank existiert bereits",
		window,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
		)
		dialog.has_separator = false
		label = Gtk::Label.new("Diese Bank existiert bereits in der Liste!")
		image = Gtk::Image.new(Gtk::Stock::DIALOG_ERROR, Gtk::IconSize::DIALOG)

		hbox = Gtk::HBox.new(false, 5)
		hbox.border_width = 10
		hbox.pack_start_defaults(image);
		hbox.pack_start_defaults(label);
		dialog.vbox.add(hbox)
		dialog.show_all
		dialog.run
		dialog.destroy
		return nil
	end
	# puts b.attributes["name"] + " " + b.attributes["blz"]
	bank_expa = Gtk::Expander.new("")
	bank_expa.use_markup = true
	# $stderr.puts("<b>" + name.to_s + " (" + blz.to_s + ")</b>")
	bank_expa.label = "<b>" + name.to_s + " (" + use_blz.to_s + ")</b>"
	bank_expa.label = "<b>" + name.to_s + "</b>" if skip_blz == true || blz.to_i < 1
	# We need a VBox to pack the following http/https expanders
	bank_box = Gtk::VBox.new(false, 0)
	
	# An auxiliary HBox is used to provide the gap for the https expander
	bank_auxbox1 = Gtk::HBox.new(false, 0)
	bank_expa_https = Gtk::Expander.new("")
	bank_expa_https.use_markup = true
	bank_expa_https.label = "<b>Verschlüsselte Verbindung</b>"
	bank_auxbox1.pack_start(bank_expa_https, false, 0, 20)
	
	# An auxiliary HBox to provide the gap left of the checkboxes
	# An VBox to contain the checkboxes
	check_vbox = Gtk::VBox.new(false, 0)
	check_hbox = Gtk::HBox.new(false, 0)
	xbnode.elements.each("hosts[@class='https']/host") { |host|
		$stderr.puts host.attributes["name"]
		chebo = Gtk::CheckButton.new(host.attributes["name"])
		chebo.active = true if host.attributes["active"] == 'yes'
		chebo.signal_connect("toggled") { |c|
			if c.active? == false
				host.attributes["active"] = 'no' 
				$removed_hosts = true
			else
				host.attributes["active"] = 'yes'
			end
			$stderr.puts xbnode.to_s
		}
		check_vbox.pack_start(chebo)
	}
	check_hbox.pack_start(check_vbox, false, 0, 20)
	bank_expa_https.add(check_hbox)
	
	# An auxiliary HBox is used to provide the gap for the http expander
	bank_auxbox2 = Gtk::HBox.new(false, 0)
	bank_expa_http = Gtk::Expander.new("")
	bank_expa_http.use_markup = true
	bank_expa_http.label = "<b>Unverschlüsselte Verbindung</b>"
	bank_expa_https.expanded = true
	bank_auxbox2.pack_start(bank_expa_http, false, 0, 20)
	
	# An auxiliary HBox to provide the gap left of the checkboxes
	# An VBox to contain the checkboxes
	check_vbox2 = Gtk::VBox.new(false, 0)
	check_hbox2 = Gtk::HBox.new(false, 0)
	xbnode.elements.each("hosts[@class='http']/host") { |host|
		$stderr.puts host.attributes["name"]
		chebo = Gtk::CheckButton.new(host.attributes["name"])
		chebo.active = true if host.attributes["active"] == 'yes'
		chebo.signal_connect("toggled") { |c|
			if c.active? == false
				host.attributes["active"] = 'no' 
				$removed_hosts = true
			else
				host.attributes["active"] = 'yes'
			end
			$stderr.puts xbnode.to_s
		}
		check_vbox2.pack_start(chebo)
	}
	check_hbox2.pack_start(check_vbox2, false, 0, 20)
	bank_expa_http.add(check_hbox2)
	
	bank_box.pack_start(bank_auxbox1, false, 0, 0)
	bank_box.pack_start(bank_auxbox2, false, 0, 0)
	bank_expa.add(bank_box)
	menu = Gtk::Menu.new
	eventbox = Gtk::EventBox.new
	eventbox.events = Gdk::Event::BUTTON_PRESS_MASK
	eventbox.signal_connect('button_press_event') do |w, event|
		if event.event_type == Gdk::Event::BUTTON_PRESS
			if event.button == 3   # left mouse button
				menu.popup(nil, nil, event.button, event.time)
			end
		end
	end
	eventbox.add(bank_expa)
	pwidget.pack_start(eventbox, false, 5, 5)
	# window.add(eventbox)
	eventbox.realize
	#bank_expa_http.show
	#bank_expa_https.show
	#bank_auxbox1.show
	#bank_auxbox2.show
	#bank_box.show
	eventbox.show
	bank_expa.show_all
	create_popup(menu, bank_expa, pwidget, window, check_vbox2, xbnode, blz.to_i )
	xbnode.attributes["blz"] = use_blz.to_s
	xbnode.attributes["name"] = name
	xbnode.attributes["skipblz"] = "true" if skip_blz == true
	$bankfrags[blz.to_i] = xbnode
	$pending_changes = true
end

def check_ff_running
	IO.popen("ps waux") { |l|
		while l.gets
			pname = $_.split[10].to_s
			bbpname = $_.split[2].to_s
			return true if pname.strip == "/usr/lib/firefox-3.5.5/firefox" # Testing only
			return true if bbpname =~ /firefox-bin$/
		end
	}
	return false
end

$blzfile = "/tmp/blzlist.xml"
$blzfile = "/etc/lesslinux/banking/blzlist.xml" if File.exists?("/etc/lesslinux/banking/blzlist.xml")
$cfgdir = "/tmp"
$cfgdir = "/etc/lesslinux/banking" if system("test -d /etc/lesslinux/banking")
$blzxml = REXML::Document.new(File.new($blzfile))
$blzlist = prep_blz_list($blzxml)
$bankfrags = Hash.new
$banknames = Hash.new
$deleted_banks = Array.new
$removed_hosts = false
$outdir = "/tmp/banks"
$outdir = "/etc/smack/banks" if system("test -d /etc/smack/banks")
$blzdir = "../crawlout"
$blzdir = "/etc/lesslinux/banking/descs" if system("test -d /etc/lesslinux/banking/descs")
$blzdir = "/usr/share/lesslinux/banking/descs" if system("test -d /usr/share/lesslinux/banking/descs")
$prefs = "/tmp/pres.js"
$prefs = "/home/surfer/.mozilla/firefox/default_profile/prefs.js" if File.exists?("/home/surfer/.mozilla/firefox/default_profile/prefs.js")
$pending_changes = false

# These global variables are used by the crawler, we might ocassionally reset them:

# check_ff_running


# banklist = REXML::Document.new(File.new("banklist.xml"))


window = Gtk::Window.new
window.border_width = 10
window.set_size_request(200, -1)
window.title = "Freigegebene Banken"

window.signal_connect('delete_event') { 
	if $pending_changes == false
		false
		Gtk.main_quit
	else
		retmsg = true
		# Show a dialog
		dialog = Gtk::Dialog.new(
		"Nicht gespeicherte Änderungen",
		nil,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
		[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]
		)
		dialog.default_response = Gtk::Dialog::RESPONSE_CANCEL
		msg = Gtk::Label.new("Es liegen noch nicht gespeicherte Änderungen vor.\n\nWollen Sie das Programm wirklich beenden und noch nicht gespeicherte Änderungen verlieren?")
		msg.wrap = true
		dlimage = Gtk::Image.new(Gtk::Stock::DIALOG_WARNING, Gtk::IconSize::DIALOG)
		dlhbox = Gtk::HBox.new(false, 5)
		dlhbox.border_width = 10
		dlhbox.pack_start_defaults(dlimage);
		dlhbox.pack_start_defaults(msg);
		dialog.vbox.add(dlhbox)
		dialog.show_all
		dialog.run do |response|
			if response == Gtk::Dialog::RESPONSE_OK
				retmsg = false
			elsif response == Gtk::Dialog::RESPONSE_CANCEL
				retmsg = true
			end
		end
		dialog.destroy
		retmsg 
		# Gtk.main_quit if retmsg == false
	end
}
window.signal_connect('destroy') { 
	# Gtk.main_quit if $pending_changes == false
	false
	Gtk.main_quit
}


bankbox = Gtk::VBox.new(false, 0)
bpos = 0

pmenu = Gtk::Menu.new
evbox = Gtk::EventBox.new
evbox.events = Gdk::Event::BUTTON_PRESS_MASK
evbox.signal_connect('button_press_event') do |w, event|
	if event.event_type == Gdk::Event::BUTTON_PRESS
		if event.button == 3   # left mouse button
			pmenu.popup(nil, nil, event.button, event.time)
		end
	end
end
evbox.add(bankbox)
# pwidget.pack_start(evbox, false, 5, 5)
evbox.realize
evbox.show
create_panel_popup(pmenu, bankbox, window)

scroll_pane = Gtk::ScrolledWindow.new
scroll_pane.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
scroll_pane.add_with_viewport(evbox)

# window.add(scroll_pane)

vlayout = Gtk::VBox.new(false, 0)
vlayout.pack_start(scroll_pane, true, true, 0)
new_butt = Gtk::Button.new("Bank hinzufügen")
save_butt = Gtk::Button.new("Einstellungen speichern")
button_box = Gtk::HBox.new(true, 0)
button_box.pack_start(new_butt, true, true, 0)
button_box.pack_start(save_butt, true, true, 0)
vlayout.pack_start(button_box, false, true, 0)
save_butt.signal_connect("clicked") { write_back(window) }
new_butt.signal_connect("clicked") { select_bank(window, bankbox) }
window.add(vlayout)

if File.exist?($cfgdir + "/allowedservers.xml")
	begin
		xmlf = File.open($cfgdir + "/allowedservers.xml")
		allowedbanks = REXML::Document.new(xmlf)
		xmlf.close
		allowedbanks.elements.each("allowedbanks/bank") { |hostnode|
			puts hostnode.to_s
			blz = hostnode.attributes["blz"].to_i
			name = hostnode.attributes["name"].to_s
			begin 
				skipblz = hostnode.attributes["skipblz"].to_s
			rescue
				skipblz = "false"
			end
			puts blz
			if skipblz == "true"
				add_bank(hostnode, bankbox, window, blz, name, true)
			else
				add_bank(hostnode, bankbox, window, blz, name, false)
			end
		}
		$pending_changes = false
	rescue
	end
end

window.set_size_request(400, 450)
window.show_all

show_warning(window, "Bitte schließen Sie das Internet-Zugangsprogramm bevor Sie mit der Einstellung Ihrer Bank fortfahren.") if check_ff_running

select_bank(window, bankbox) if $bankfrags.length < 1

# window.add(expa_codi)
#window.show_all

Gtk.main
