#!/usr/bin/ruby
# encoding: utf-8

require 'rexml/document'

def write_smack_rules
	valid_hosts = Array.new
	valid_ips = Array.new
	hostcount = 0
	dnscount = 0
	$bankfrags.each { |k, v|
		if $deleted_banks.include?(k)
			$stderr.puts("Skipping deleted bank: " + k.to_s)
		else
			v.elements.each("hosts/host") { |h|
				if h.attributes["active"] == "yes"
					# $stderr.puts(h.attributes["name"])
					valid_hosts.push(h.attributes["name"])
				end
			}
		end
	}
	valid_hosts.uniq!
	valid_hosts.each { |h|
		inside_answer = false
		# $stderr.puts("Valid: " + h)
		if check_for_ip(h) == true
			valid_ips.push(h)
		else
			hostcount += 1
			IO.popen("nslookup '" + h + "'") { |io|
				while io.gets
					toks = $_.split
					inside_answer = true if toks[0] =~ /^Name:/
					if inside_answer == true && !toks[1].nil? && toks[0] =~ /^Address:/
						valid_ips.push(toks[1])
						dnscount += 1
					elsif inside_answer == true && !toks[2].nil? && toks[0] =~ /^Address/ && toks[1] =~ /:$/
						valid_ips.push(toks[2])
						dnscount += 1
					end
				end
			}
		end
	}
	# Add nameservers to valid_ips
	File.open("/etc/resolv.conf").each { |line|
		toks = line.split
		valid_ips.push(toks[1].strip) if toks[0].strip =~ /^nameserver/
	}
	system("rm " + $outdir + "/smack.netlabel.???.txt")
	valid_ips.uniq!
	ofcount = 0
	valid_ips.each { |ip|
		$stderr.puts("Dumping: " + ip)
		outfile = File.open($outdir + "/smack.netlabel." + sprintf("%03d", ofcount) + ".txt", 'w')
		outfile.write(ip + " outgoing\n") 
		outfile.close
		system("cat " + $outdir + "/smack.netlabel." + sprintf("%03d", ofcount) + ".txt > /smack/netlabel")
		ofcount += 1
	}
	return dnscount - hostcount
end

def check_for_ip(host_or_ip)
	toks = host_or_ip.split(".")
	return false unless toks.size == 4
	return false if toks[0].to_i < 2
	toks.each { |t|
		return false if t.to_i < 1 || t.to_i > 255 
	}
	return true
end

$deleted_banks = Array.new # must be empty, but exist
$bankfrags = Hash.new
$blzfile = "/tmp/blzlist.xml"
$blzfile = "/etc/lesslinux/banking/blzlist.xml" if File.exists?("/etc/lesslinux/banking/blzlist.xml")
$cfgdir = "/tmp"
$cfgdir = "/etc/lesslinux/banking" if system("test -d /etc/lesslinux/banking")
$outdir = "/tmp/banks"
$outdir = "/etc/smack/banks" if system("test -d /etc/smack/banks")
$blzxml = REXML::Document.new(File.new($blzfile))

xmlf = File.open($cfgdir + "/allowedservers.xml")
allowedbanks = REXML::Document.new(xmlf)
xmlf.close

allowedbanks.elements.each("allowedbanks/bank") { |hostnode|
	# puts hostnode.to_s
	blz = hostnode.attributes["blz"].to_i
	name = hostnode.attributes["name"].to_s
	puts blz
	# add_bank(hostnode, bankbox, window, blz, name)
	$bankfrags[blz.to_i] = hostnode
}

write_smack_rules
